import numpy as np
import cv2

def bw1(src):
	return cv2.cvtColor(src,cv2.COLOR_BGR2GRAY);

def bw2(src):
    channels = np.asarray(cv2.split(src),np.uint16)
    dst = (channels[0]+channels[1]+channels[2])/3
    return np.asarray(dst,np.uint8)

def bw3(src): # slow
    dst = np.zeros(src.shape[:2],np.uint8)
    for y in range(src.shape[0]):
        for x in range(src.shape[1]):
            dst[y,x] = (np.uint16(src[y,x,0])+src[y,x,1]+src[y,x,2])//3
    return dst

image = cv2.imread("../lena.jpg",cv2.IMREAD_COLOR)

print("press 1, space, 2, space, ... 3, esc");
gray = image
while True:
    cv2.imshow("lena",gray)
    key = cv2.waitKey(0)
    if key == ord('1'):
        gray = bw1(image)
    elif key == ord('2'):
        gray = bw2(image)
    elif key == ord('3'):
        gray = bw3(image)
    elif key == ord(' '):
        gray = image
    elif key == 27:
        break

cv2.destroyAllWindows()
