import cv2
import numpy as np
 
threshold_from = 0
threshold_to = 0

def updateThreshold_from( *args ):
    global threshold_from
    threshold_from = args[0]

def updateThreshold_to( *args ):
    global threshold_to
    threshold_to = args[0]

cv2.namedWindow("HSV filter")
cv2.createTrackbar("from", "HSV filter", threshold_from, 179, updateThreshold_from)
cv2.createTrackbar("to", "HSV filter", threshold_to, 179, updateThreshold_to)

last_from = threshold_from
last_to = threshold_to

image = cv2.imread("../lena.jpg")
cv2.imshow("HSV filter",image)
 
while True:
    
    if threshold_from != last_from or threshold_to != last_to:
        print("changed")
        last_from = threshold_from
        last_to = threshold_to
        
        hsv = cv2.cvtColor(image,cv2.COLOR_BGR2HSV)
        mask = cv2.inRange(hsv, np.array([threshold_from,120,70]), np.array([threshold_to,255,255]))
        filtered = np.copy(image)
        filtered[mask > 0] = (255,255,0)
    
        cv2.imshow("HSV filter",filtered)
    
    if cv2.waitKey(10) == 27:
        break
    
cv2.destroyAllWindows()
